laravel8-crud-resources/routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\ItemResourceController;

Route::get('/', function () {
    return redirect('items');
});
Route::resource('items', ItemResourceController::class);

laravel8-crud-resources/app/Models/Item.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Item extends Model
{
    use HasFactory, SoftDeletes;

    protected $guarded = [];
    protected $fillable = [
        'name',
        'description',
        'image',
    ];
}

laravel8-crud-resources/app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

laravel8-crud-resources/app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

laravel8-crud-resources/app/Http/Controllers/ItemResourceController.php
<?php

namespace App\Http\Controllers;

use App\Models\Item;
use Illuminate\Http\Request;
use Illuminate\Http\UploadedFile;
use Illuminate\Support\Facades\File;

class ItemResourceController extends Controller
{
    /**
     * Path to public storage
     */
    private $imageStorage = 'uploads/items/images';

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $items = Item::orderByDesc('id')->paginate(10);

        return view('items.index', compact('items'))
            ->with('i', (request()->input('page', 1) - 1) * 5);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('items.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'image' => 'image|mimes:jpeg,png,jpg,gif,svg|max:4048|nullable',
        ]);

        if ($request->image) {

            $postData = [
                'name' => $request->name,
                'description' => $request->description,
                'image' => $this->storeImage($request->image)
            ];

        } else {

            $postData = [
                'name' => $request->name,
                'description' => $request->description,
                'image' => null
            ];
        }

        if (Item::create($postData)) {
            return redirect()->route('items.index')
                ->with('success','Item created successfully.');
        }

        return redirect()->route('items.index')
                ->with('failure','Item can not be created.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Item  $item
     * @return \Illuminate\Http\Response
     */
    public function show(Item $item)
    {
        return view('items.show',compact('item'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Item  $item
     * @return \Illuminate\Http\Response
     */
    public function edit(Item $item)
    {
        return view('items.edit', compact('item'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Item  $item
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Item $item)
    {
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'image' => 'image|mimes:jpeg,png,jpg,gif,svg|max:4048|nullable',
        ]);

        $postData = $request->all();

        if ($request->image) {

            $postData = [
                'name' => $request->name,
                'description' => $request->description,
                'image' => $this->storeImage($request->image)
            ];
        } elseif ($request->delete) {
            $this->destroyImage($item->image);
        }

        if ($item->update($postData)) {
            return redirect()->route('items.index')
                ->with('success','Item updated successfully');
        }

        return redirect()->route('items.index')
            ->with('failure','Item can not be updated.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Item  $item
     * @return \Illuminate\Http\Response
     */
    public function destroy(Item $item)
    {
        if ($item->image) {
            $this->destroyImage($item->image);
        }
        if ($item->delete()) {

            return redirect()->route('items.index')
                ->with('success','Item deleted successfully.');
        }
        return redirect()->route('items.index')
                ->with('failure','Item can not be deleted.');
    }

    /**
     * Store item image.
     *
     * @param Illuminate\Http\UploadedFile $image
     * @return String
     */
    private function storeImage(UploadedFile $image) : String
    {
        $path = 'public/' . $this->imageStorage;

        if (File::exists($path)) {
            File::delete($path);
        }
        $image->store($path);
        return $image->hashName();
    }

    /**
     * Remove item image.
     *
     * @param String $file
     * @return Bool
     */
    private function destroyImage(String $file) : Bool
    {
        $path = 'storage/' . $this->imageStorage . '/' . $file;
        // dd(File::exists($path), $path);
        if (File::exists($path)) {
            return File::delete($path);
        }

        return false;
    }
}

laravel8-crud-resources/resources/views/items/create.blade.php
@extends('layouts.crud')

@section('content')

<div class="row">
    <div class="col my-3 text-center">
        <h2 class="h6 text-primary"> - Add new Item -</h2>
    </div>
</div><!-- .row -->

@if ($errors->any())
<div class="row">
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach ($errors->all() as $error)
            <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
</div><!-- .row -->
@endif

<div class="row">
    <div class="col">
        <form action="{{ route('items.store') }}" method="POST" enctype="multipart/form-data" class="bg-light border py-4 px-3 shadow">@csrf @include('components.form')</form>
    </div>
</div><!-- .row -->

@endsection

laravel8-crud-resources/resources/views/items/edit.blade.php
@extends('layouts.crud')

@section('content')

<div class="row">
    <div class="col my-3 text-center">
        <h2 class="h6 text-primary"> - Add new Item -</h2>
    </div>
</div><!-- .row -->

@if ($errors->any())
<div class="row">
    <div class="alert alert-danger">
        <strong>Whoops!</strong> There were some problems with your input.<br><br>
        <ul>
            @foreach ($errors->all() as $error)
            <li>{{ $error }}</li>
            @endforeach
        </ul>
    </div>
</div><!-- .row -->
@endif

<div class="row">
    <div class="col">
        <form action="{{ route('items.update', $item->id) }}" method="POST" enctype="multipart/form-data" class="bg-light border py-4 px-3 shadow">
            @csrf
            @method('PUT')
            @include('components.form')
        </form>
    </div>
</div><!-- .row -->

@endsection

laravel8-crud-resources/resources/views/items/index.blade.php
@extends('layouts.crud')

@section('content')

<div id="list">

    @include('components.pagination')

    @isset($items)
    <div class="table-responsive">

        <table class="table table-striped table-hover">

            <thead>
                <tr>
                    <th class="th-sm">ID</th>
                    <th class="th-lg">Image</th>
                    <th class="th-lg">Name</th>
                    <th class="th-lg">Action</th>
                </tr>
            </thead>
            @foreach($items as $item)
            <tr>
                <td>{{ $item->id }}</td>
                <td>
                    @if($item->image)
                        <img src="{{ asset('storage/uploads/items/images/' . $item->image) }}" alt="{{ $item->description }}" class="border rounded my-1 mx-3" height="35" />
                    @else
                        -
                    @endif
                </td>
                <td>{{ $item->name }}</td>
                <td class="text-end">
                   <form action="{{ route('items.destroy',$item->id) }}" method="POST">

                        <a class="btn btn-info btn-sm m-2" href="{{ route('items.show',$item->id) }}">Show</a>
                        <a class="btn btn-primary btn-sm m-2" href="{{ route('items.edit',$item->id) }}">Edit</a>

                        @csrf
                        @method('DELETE')

                        <button type="submit" class="btn btn-danger btn-sm m-2" >Delete</button>
                    </form>
                </td>
            </tr>
            @endforeach
        </table>

    </div><!-- .table-responsive -->
    @endif

   @include('components.pagination')

</div><!-- #list -->

@endsection

laravel8-crud-resources/resources/views/items/show.blade.php
@extends('layouts.crud')

@section('content')

<div class="row">
    <div class="col my-3 text-center">
        <h2 class="h6 text-primary"> - {{ $item->name }} -</h2>
    </div>
</div><!-- .row -->

 <div class="row my-3">
    <div class="col">
        <h2>{{ $item->name }}</h2>
    </div>
</div><!-- .row -->
<div class="row">

     @if ($item->image)
     <div class="col-2">
        <img src="{{ asset('storage/uploads/items/images/' . $item->image) }}" alt="{{ $item->description }}" />
    </div>
    @endif

    <div class="col">
        {{ $item->description }}
    </div>

</div><!-- .row -->

@endsection

laravel8-crud-resources/resources/views/layouts/crud.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel 8 CRUD with [Items]') }}</title>

        <!-- Scripts -->
        <script src="{{ asset('js/app.js') }}" defer></script>
        <!-- Styles -->
        <link href="{{ asset('css/app.css') }}" rel="stylesheet">
    </head>
    <body class="font-sans antialiased">

        <div class="min-h-screen bg-gray-100">

            <main class="container">

                <!-- Nav -->
                @include('components.nav')

                <!-- Messages -->
                <div id="messages" class="row my-3">

                    <div class="col">

                        @if($message = Session::get('success'))
                            <div class="alert alert-success">
                                <p>{{ $message }}</p>
                            </div>
                        @elseif($message = Session::get('failure'))
                            <div class="alert alert-warning">
                                <p>{{ $message }}</p>
                            </div>
                        @endif

                    </div>

                </div><!-- .row -->

                <!-- Content -->
                <div class="row">

                    <div class="col">@yield('content')</div>

                </div><!-- .row -->

            </main><!-- .container -->

        </div>
    </body>
</html>